#include <zephyr/logging/log.h>
LOG_MODULE_REGISTER(bh1750);

#include <zephyr/kernel.h>
#include <zephyr/sys/byteorder.h>
#include <zephyr/device.h>
#include <stdbool.h>

#include <zephyr/drivers/sensor.h>

#include <math.h>

#include "bh1750.h"

#if !DT_HAS_COMPAT_STATUS_OKAY(rohm_bh1750)
#error "No rohm,bh1750 compatible node found in the device tree"
#endif

const struct device *const bh = DEVICE_DT_GET_ANY(rohm_bh1750);
 
int bh1750_setup()
{

  if (!device_is_ready(bh) || bh1750_probe()) {
		printk("Device %s is not ready.\n", bh->name);
		return -1;
	}

  return 0;
};

int bh1750_probe()
{
  if(sensor_sample_fetch(bh))
  {
    printk("Failed to fetch sample from BH1750 device\n");
    return -1;
  }
    return 0;
}

double bh1750_ReadLight()
{
  	struct sensor_value lux;
  		sensor_channel_get(bh, SENSOR_CHAN_LIGHT, &lux);

  
		 return sensor_value_to_double(&lux);
}

