#include <zephyr/logging/log.h>
LOG_MODULE_REGISTER(sht4x);

#include <zephyr/kernel.h>
#include <zephyr/sys/byteorder.h>
#include <zephyr/device.h>
#include <stdbool.h>

#include <zephyr/drivers/sensor/sht4x.h>

#include <math.h>

#include "sht4x.h"

#if !DT_HAS_COMPAT_STATUS_OKAY(sensirion_sht4x)
#error "No sensirion,sht4x compatible node found in the device tree"
#endif

const struct device *const sht = DEVICE_DT_GET_ANY(sensirion_sht4x);
 
int sht4x_setup()
{

  if (!device_is_ready(sht)) {
		printk("Device %s is not ready.\n", sht->name);
		return -1;
	}
  return 0;
};

int sht4x_probe()
{
		if (sensor_sample_fetch(sht)) {
			printk("Failed to fetch sample from SHT4X device\n");
			return -1;
		}
  return 0;
}

double sht4x_ReadTempeature()
{
  	struct sensor_value temp;
  		sensor_channel_get(sht, SENSOR_CHAN_AMBIENT_TEMP, &temp);

  
		 return sensor_value_to_double(&temp);
}

double sht4x_ReadHumidity()
{
  	struct sensor_value hum;
		sensor_channel_get(sht, SENSOR_CHAN_HUMIDITY, &hum);

  
		 return sensor_value_to_double(&hum);
}
